import numpy as np
import copy

##################################################
# Partie 1                                       #
##################################################

# Methode de Newton
#  - Entree : f (fonction), df (fonction), x0 (reel), iteMax (entier), eps (reel), dd (data)
#  - Sortie : xx (tableau reel)	    
def Newton(f,df,x0,iteMax,eps,dd):
    xx = [x0]
    x1 = x0 * 2 + 1
    err = x1 - x0
    
    ite = 0
    while ( (np.abs(err) > eps) and (ite < iteMax) ):
        # Completer ICI :
        #x1 = ...
        
        xx.append(x1)
        err = (x1 - x0)
        x0 = x1
        ite = ite + 1
    
    print ite    
    print err
    
    return xx
    
# Methode de Newton
#  - Entree : f (fonction), x0 (reel), iteMax (entier), eps (reel), dd (data)
#  - Sortie : xx (tableau reel)	    
def FP(f,x0,x1,iteMax,eps,dd):
    xx = [x0]
    xx.append(x1)
    x2 = x1 * 2 + 1
    err = x2 - x1 
    
    f0 = f(x0,dd)
    ite = 0
    while ( (np.abs(err) > eps) and (ite < iteMax)):
        f1 = f(x1,dd)
        # Completer ICI :
        #x2 = ...
        #...
        
        err = x2 - x1
        
        
        xx.append(x2)
        x0 = x1
        x1 = x2
        
        
        ite = ite + 1
        
    return xx
    
    
##################################################
# Partie 2                                       #
##################################################    

#Methode de Newton 2D
# - Entree : f (fonction), df (fonction), x0 (reel), iteMax (entier), eps (reel), dd (data)
# - Sortie : xx (tableau reel)
def Newton2D(f,df,x0,iteMax,eps,dd):
    xx = [x0]
    x1 = x0 * 2 + 1
    err = x1 - x0

    ite = 0
    while ( (np.dot(err,err) > eps * eps) and (ite < iteMax) ):
        x1 = x0 - np.linalg.solve(df(x0,dd),f(x0,dd))
        xx.append(x1)
        err = (x1 - x0)
        x0 = x1
        ite = ite + 1

    return xx
    
    
##################################################
# Partie 3                                       #
##################################################    

#Methode de Horner
# - Entree : p (tableau), s (reel)
# - Sortie : r0 (reel), q (tableau)
def Horner(p,s):
    degre = len(p) - 1
    q = []
    r0 = 0
    
    # Completer ICI 
    #for i in ...
    # ...
    
    return [r0,q]


#Methode de Newton - Horner
# - Entree : p (tableau), s0 (reel), iteMax (entier), eps (reel)
# - Sortie : s1 (reel), ite (entier)
def NewtonHorner(p,s0,iteMax,eps):
    s1 = s0*1.0 + 1
    
    ite = 0
    while ((ite < iteMax) and (np.abs(s0 - s1) > eps)):
        if (ite > 0):
            s0 = s1
            
        # Completer ICI :    
        #[ps0,q] = ...
        #[qs0,r] = ...
        if (np.abs(qs0) < 1e-15):
            print "Pb division par 0"
            return [s0,iteMax]
        # s1 = ...

        ite = ite + 1
    
    #print ite
    return [s1,ite]
    
    
    
def myfind(list,ele):
    ind = -1
    for j,e in enumerate(list):
        if (np.abs(e-ele) < 1e-5):
            ind = j
            return ind
    return ind