import numpy as np
import matplotlib.pyplot as plt

import algo
import data
import affichage




"""
    Lambda - mecanisme
"""

########################################
# Parametres methode et mechanisme 
########################################

a = 4.0 
b = 5.0 
c = 5.0  
d = 2.0

# -20 + 20*cos(alpha) - 16

tol = 1e-8
iteMax = 1000

N = 50


########################################
# Resolution effective du probleme
########################################

list_theta = (np.arange(2*N) / (1.0*N) ) * np.pi
list_xy = []

for theta in list_theta:
    if (len(list_xy) > 1):
        x0 = list_xy[-1]
    else:
        x0 = np.array([3,5])
    
    xx = algo.Newton2D(data.F2D, data.dF2D, x0, iteMax, tol, [theta,a,b,c,d])
    list_xy.append(xx[-1])

########################################
# Affichage de la solution
########################################


affichage.animationLambda(list_theta,list_xy,a,b,c,d)


print "FIN \n"
########################################




