import numpy as np
import matplotlib.pyplot as plt

import algo
import data
import affichage




"""
    Calcul racine cubique
"""

########################################
# Parametres methode
########################################

tol = 1e-7
iteMax = 501

# degre polynome
n = 4 # 0 < n <= 10

# echantillonage
step = 0.01 # Attention pour step < 0.01, le programme devient long...

list_r = []


########################################
# Resolution effective du probleme
########################################

p = np.arange(n+1)*0.0
p[0] = -1.0
p[n] = 1.0

xx = np.arange(-1,1,step)
yy = np.arange(-1,1,step)

zz = np.zeros((len(xx),len(yy)))

for i,x in enumerate(xx):
    print i," / ",len(xx)
    for j,y in enumerate(yy):
        s0 = complex(x,y)
        [r,ite] = algo.NewtonHorner(p,s0,iteMax,tol)
        ind = algo.myfind(list_r,r)
        if (ind >= 0):
            zz[i,j] = ind
        else:
            if (ite < iteMax-1):
                list_r.append(r)
                zz[i,j] = len(list_r)-1
            else:
                zz[i,j] = -1


########################################
# Affichage de la solution
########################################

affichage.afficherPoints(xx,yy,zz)


print "FIN \n"
########################################




